// JStore is a simple API wrapper of 'jstorage', a cross-browser key-value store database to
//        persistently store data locally through a browser.  Under-pinning layer can be prototype or JSON2.
//        We are using JSON2 to avoid the need of using jQuery.noConflict() and altering all subsequent jQuery code.
//
// Requires:	<script src="json2.js"> & <script src="jstorage.js">
//
function jStoreSet(key, val)
{
	if (key)
	{
		return $.jStorage.set(key, val);
	}
	return false;
}

function jStoreGet(key)
{
	var value = $.jStorage.get(key);
	return value;
}

function jStoreIndex()
{
	var index;
	index = $.jStorage.index();
	// massage the index?
	return index;
}

function jStoreDelete(key)
{
	$.jStorage.deleteKey(key);
	return key;
}

function jStoreFlush()
{
	$.jStorage.flush(); // dangerous.
}
