//
// Twisty Box.
//
// Expand or Retract block divs on a trigger. Expand/Retract handle the generic. Can animate or 'snap'.
// TwistOpen/TwistClose handle twisty boxes, with an associated open/close trigger that changes in tandem.
//
function twistopen(baseid, num)
{
	for (var i=1 ; i < 6 ; i++ )
	{
		twistclose(baseid, i);
	}
	var target = document.getElementById(baseid + num);
	if ( target )
	{
		var openicon = document.getElementById(baseid + "open" + num);
		var closeicon = document.getElementById(baseid + "close" + num);
		openicon.style.display = "none";
		openicon.blur;
		closeicon.style.display = "block";
		closeicon.blur;
		target.style.display = "block";
		target.blur;
	}
}
function twistclose(baseid, num)
{
	var target = document.getElementById(baseid + num);
	if ( target )
	{
		var openicon = document.getElementById(baseid + "open" + num);
		var closeicon = document.getElementById(baseid + "close" + num);
		openicon.style.display = "block";
		closeicon.style.display = "none";
		target.style.display = "none";
		target.blur;
		openicon.blur;
		closeicon.blur;
	}
}

	

function expand(element){
	var target = document.getElementById(element);
	var h = target.offsetHeight;
	var sh = target.scrollHeight;
	var loopTimer = setTimeout('expand(\''+element+'\')',8);
	if(h < sh){
		h += 5;
	} else {
		clearTimeout(loopTimer);
	}
	target.style.height = h+"px";
}
function retract(element){
	var target = document.getElementById(element);
	var h = target.offsetHeight;
	var loopTimer = setTimeout('retract(\''+element+'\')',8);
	if(h > 0){
		h -= 5;
	} else {
		target.style.height = "0px";
		clearTimeout(loopTimer);
	}
	target.style.height = h+"px";
}
