﻿//
// Questions:
//		The questions are defined in data_common.js
//
// CompQuestions:   (Component-Specific Question List)
//		key: The order of the array defines the user-facing question number. Re-arrange the order to change displayed order.
//		val: UQI, Module, Category, [x, y]...[x,y]..[x,y]..
//			 where x is value 0, 1, or 2.
//				0 == text not overriding. (I.e., leave base question text alone.)  This should be used as (0, "") when used.
//				1 == text overriding base question text.  
//				2 == text appended to base question text.
//			This allows component-specific text to any of the fields defined by a question.
//
var CompQuestions = [
	[1,   3, 2],	// Question with Unique Identifier 1 appears in Module 2 Category 1.  It has no text overriding.
	[2,   3, 2],
	[3,   3, 2],
	[7,   3, 3],
	[8,   3, 3],
	[12,  3, 4],
	[13,  3, 4],
	[14,  3, 5, 2, " for S&A", 1, "S&A (S and A) - The dashboard should have the coolests data storage ever."],
	[100, 1, 2],
	[101, 1, 2],
	[102, 1, 2]
	
];	/* end CompQuestions */

var Modules = null;  // If set to null, "CommonModules" - the default - is used.
var ModulesAbbrs = null;  // If set to null, "CommonModulesAbbrs" - the default - is used.
